/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintrag;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class ErgebnisLogEintragExtendedDAO extends AbstractErgebnisLogEintragDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: ErgebnisOrderByPositionNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM ErgebnisLogEintrag o WHERE o.ergebnis= ?1 ORDER BY o.position<br>
* SQL: <br>
*/
@Override
public java.util.List<ErgebnisLogEintrag> findByErgebnisOrderByPosition( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisLogEintrag.findByErgebnisOrderByPosition" ,  ergebnis  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebnisOrderByPosition(): Miss");
        }

        cache.put(key, super.findByErgebnisOrderByPosition( ergebnis  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebnisOrderByPosition(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<ErgebnisLogEintrag>) cache.lookup(key));
    }

    return super.findByErgebnisOrderByPosition( ergebnis  );
}
/**
* Name: ErgebnisUndArtOrderByPositionNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM ErgebnisLogEintrag o WHERE o.ergebnis= ?1 AND ergebnisLogEintragArt = ?2 ORDER BY o.position<br>
* SQL: <br>
*/
@Override
public java.util.List<ErgebnisLogEintrag> findByErgebnisUndArtOrderByPosition( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintragArt ergebnisLogEintragArt) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisLogEintrag.findByErgebnisUndArtOrderByPosition" ,  ergebnis ,  ergebnisLogEintragArt  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebnisUndArtOrderByPosition(): Miss");
        }

        cache.put(key, super.findByErgebnisUndArtOrderByPosition( ergebnis ,  ergebnisLogEintragArt  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebnisUndArtOrderByPosition(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<ErgebnisLogEintrag>) cache.lookup(key));
    }

    return super.findByErgebnisUndArtOrderByPosition( ergebnis ,  ergebnisLogEintragArt  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
